--[[
code.c is where this code is being used!
This is just so you can see this.
]]

function replace( str, tofind, toreplace )
	tofind = tofind:gsub( "[%-%^%$%(%)%%%.%[%]%*%+%-%?]", "%%%1" )
	toreplace = toreplace:gsub( "%%", "%%%1" )
	return ( str:gsub( tofind, toreplace ) )
end

function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end

function wait(n)
	local Current=os.time()
	local Goal=Current+n
	repeat until os.time()>=Goal
end

function scandir(directory)
    local i, t, popen = 0, {}, io.popen
    for filename in popen('dir "'..directory..'" /b'):lines() do
        i = i + 1
        t[i] = filename
    end
    return t
end

function SaveFile(file,Data)
	local new=io.open(file, "w")
	if new == nil then return end
	if not Data or Data == "" then Data = " " end
	new:write(Data)
	new:close()
end

function fixShit(file)
	local Main=io.open(file)
	local Data={}
	local Current = file
	local shouldSave = true
	for line in Main:lines() do
		if not line then line="" end
		if string.find(line,"--[[", nil, true) or string.find(line, "/*", nil, true) then
			print("Found comment start in "..file)
			shouldSave = false
		elseif string.find(line, "]]", nil, true) or string.find(line, "*/", nil, true) then
			print("Found comment end in "..file)
			shouldSave = true
		elseif string.find(line, "//") and shouldSave then
			print("Found comment start in "..file)
			local newLine, num = string.gsub(line, "//", "--")
			print(newLine)
			if not Data[Current] then Data[Current]="" end
			Data[Current]=Data[Current]..newLine.."\n"
		elseif shouldSave then
			if not Data[Current] then Data[Current]="" end
			Data[Current]=Data[Current]..line.."\n"
		end
	end
	SaveFile(file, Data[Current])
end

function scanning( dir )
	for k,v in pairs(scandir(dir)) do
		if file_exists(dir..v) then
			if string.find(v, ".lua") then
				fixShit(dir..v)
				os.execute('cscript '..scriptdir..' \"'..dir..v..'\" \"'..dir..v..'\" -verbose -s')
			else
				print(dir..v)
			end
		else
			scanning( dir..v..'/' )
		end
	end
end

function startup()
	print("Location of lua file(s) \n Example: C:/Users/John/Desktop/addons/ \n Remember the last slash!")
	directory = io.read()
	print("Location of the HW2 Pretty Printer script. \n Example: C:/Users/John/Desktop/Prettifier/HW2_PrettyPrinter.js \n Remember the .js!")
	scriptdir = io.read()
	print("Starting in 3 seconds.")
	wait(3)
end

startup()

print("Scanning "..directory)
scanning(directory)

print("Finished")
wait(math.huge)